#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const float eps=0.000001;

int n, k;
float a[300005];
float b[300005];
float c[300005];

bool check(float s)
{
    c[0]=0;
    for(int i=1; i<=n; i++) b[i]=a[i]-s;
    float mi=0;
    for(int i=1; i<k; i++) c[i]=c[i-1]+b[i];
    for(int i=k; i<=n; i++)
    {
        c[i]=c[i-1]+b[i];
        if(c[i-k]<mi) mi=c[i-k];
        if(c[i]-mi>-eps) return 1;
    }
    return 0;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>k;
    for(int i=1; i<=n; i++) cin>>a[i];
    float le=0, ri=1e6;
    while(ri-le>eps)
    {
        float mid=(le+ri)/2;
        if(check(mid)) le=mid;
        else ri=mid;
    }
    cout<<fixed<<setprecision(6)<<le<<endl;
    return 0;
}
